<template>
  <j-modal
    :title="title"
    :width="width"
    :visible="visible"
    :confirmLoading="confirmLoading"
    switchFullscreen
    @ok="handleOk"
    @cancel="handleCancel"
    cancelText="关闭">
    <a-spin :spinning="confirmLoading">
      <a-form-model ref="form" :model="model" :rules="validatorRules">
        <a-form-model-item label="区域名称" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="name">
          <a-input v-model="model.name" placeholder="请输入区域名称" ></a-input>
        </a-form-model-item>
        <a-form-model-item label="选择上级" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="parentid">
          <j-tree-select
            ref="treeSelect"
            placeholder="请选择上级"
            v-model="model.parentid"
            dict="base_space,name,id"
            pidField="parentid"
            pidValue="0"
            hasChildField="has_child"
            >
          </j-tree-select>
        </a-form-model-item>
        <!-- <a-form-model-item label="编号" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="serialnum">
          <a-input v-model="model.serialnum" placeholder="请输入编号" ></a-input>
        </a-form-model-item>
        <a-form-model-item label="类型" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="spacetype">
          <a-input v-model="model.spacetype" placeholder="请输入类型" ></a-input>
        </a-form-model-item>
        <a-form-model-item label="管理单位/部门" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="deptid">
          <a-input v-model="model.deptid" placeholder="请输入管理单位/部门" ></a-input>
        </a-form-model-item>
        <a-form-model-item label="建筑面积（平方米）" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="builtarea">
          <a-input-number v-model="model.builtarea" placeholder="请输入建筑面积（平方米）" style="width: 100%" />
        </a-form-model-item>
        <a-form-model-item label="空调系统" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="aircondsys">
          <a-input v-model="model.aircondsys" placeholder="请输入空调系统" ></a-input>
        </a-form-model-item>
        <a-form-model-item label="采暖系统" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="heatsys">
          <a-input v-model="model.heatsys" placeholder="请输入采暖系统" ></a-input>
        </a-form-model-item>
        <a-form-model-item label="空调面积" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="aircondarea">
          <a-input-number v-model="model.aircondarea" placeholder="请输入空调面积" style="width: 100%" />
        </a-form-model-item>
        <a-form-model-item label="采暖面积" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="heatarea">
          <a-input-number v-model="model.heatarea" placeholder="请输入采暖面积" style="width: 100%" />
        </a-form-model-item> -->
        
      </a-form-model>
    </a-spin>
  </j-modal>
</template>

<script>

  import { httpAction } from '@/api/manage'
  import { validateDuplicateValue } from '@/utils/util'
  export default {
    name: "BaseSpaceModal",
    components: { 
    },
    data () {
      return {
        title:"操作",
        width:800,
        visible: false,
        model:{
         },
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },

        confirmLoading: false,
        validatorRules: {
          name: [
            { required: true, message: '请输入区域名称!'},
          ],
        },
        url: {
          add: "/space/space/add",
          edit: "/space/space/edit",
        },
        expandedRowKeys:[],
        pidField:"parentid"
     
      }
    },
    created () {
       //备份model原始值
       this.modelDefault = JSON.parse(JSON.stringify(this.model));
    },
    methods: {
      add (obj) {
        this.modelDefault.parentid=''
        this.edit(Object.assign(this.modelDefault , obj));
      },
      edit (record) {
        this.model = Object.assign({}, record);
        this.visible = true;
      },
      close () {
        this.$emit('close');
        this.visible = false;
        this.$refs.form.clearValidate()
      },
      handleOk () {
        const that = this;
        // 触发表单验证
       this.$refs.form.validate(valid => {
          if (valid) {
            that.confirmLoading = true;
            let httpurl = '';
            let method = '';
            if(!this.model.id){
              httpurl+=this.url.add;
              method = 'post';
            }else{
              httpurl+=this.url.edit;
               method = 'put';
            }
             if(this.model.id && this.model.id === this.model[this.pidField]){
              that.$message.warning("父级节点不能选择自己");
              that.confirmLoading = false;
              return;
            }
            httpAction(httpurl,this.model,method).then((res)=>{
              if(res.success){
                that.$message.success(res.message);
                this.$emit('ok');
              }else{
                that.$message.warning(res.message);
              }
            }).finally(() => {
              that.confirmLoading = false;
              that.close();
            })
          }else{
             return false
          }
        })
      },
      handleCancel () {
        this.close()
      },
      submitSuccess(formData,flag){
        if(!formData.id){
          let treeData = this.$refs.treeSelect.getCurrTreeData()
          this.expandedRowKeys=[]
          this.getExpandKeysByPid(formData[this.pidField],treeData,treeData)
          this.$emit('ok',formData,this.expandedRowKeys.reverse());
        }else{
          this.$emit('ok',formData,flag);
        }
      },
      getExpandKeysByPid(pid,arr,all){
        if(pid && arr && arr.length>0){
          for(let i=0;i<arr.length;i++){
            if(arr[i].key==pid){
              this.expandedRowKeys.push(arr[i].key)
              this.getExpandKeysByPid(arr[i]['parentId'],all,all)
            }else{
              this.getExpandKeysByPid(pid,arr[i].children,all)
            }
          }
        }
      }
      
      
    }
  }
</script>